package com.dhcc.finance.main.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;



public class CwGlVoucherExample {
    /**
     * cw_gl_voucher
     */
    protected String orderByClause;

    /**
     * cw_gl_voucher
     */
    protected boolean distinct;

    /**
     * cw_gl_voucher
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public CwGlVoucherExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * cw_gl_voucher 2019-10-14
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andPkVoucherIsNull() {
            addCriterion("PK_VOUCHER is null");
            return (Criteria) this;
        }

        public Criteria andPkVoucherIsNotNull() {
            addCriterion("PK_VOUCHER is not null");
            return (Criteria) this;
        }

        public Criteria andPkVoucherEqualTo(String value) {
            addCriterion("PK_VOUCHER =", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotEqualTo(String value) {
            addCriterion("PK_VOUCHER <>", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherGreaterThan(String value) {
            addCriterion("PK_VOUCHER >", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHER >=", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherLessThan(String value) {
            addCriterion("PK_VOUCHER <", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHER <=", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherLike(String value) {
            addCriterion("PK_VOUCHER like", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotLike(String value) {
            addCriterion("PK_VOUCHER not like", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherIn(List<String> values) {
            addCriterion("PK_VOUCHER in", values, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotIn(List<String> values) {
            addCriterion("PK_VOUCHER not in", values, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherBetween(String value1, String value2) {
            addCriterion("PK_VOUCHER between", value1, value2, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHER not between", value1, value2, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookIsNull() {
            addCriterion("PK_GLORGBOOK is null");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookIsNotNull() {
            addCriterion("PK_GLORGBOOK is not null");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookEqualTo(String value) {
            addCriterion("PK_GLORGBOOK =", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotEqualTo(String value) {
            addCriterion("PK_GLORGBOOK <>", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookGreaterThan(String value) {
            addCriterion("PK_GLORGBOOK >", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookGreaterThanOrEqualTo(String value) {
            addCriterion("PK_GLORGBOOK >=", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookLessThan(String value) {
            addCriterion("PK_GLORGBOOK <", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookLessThanOrEqualTo(String value) {
            addCriterion("PK_GLORGBOOK <=", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookLike(String value) {
            addCriterion("PK_GLORGBOOK like", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotLike(String value) {
            addCriterion("PK_GLORGBOOK not like", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookIn(List<String> values) {
            addCriterion("PK_GLORGBOOK in", values, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotIn(List<String> values) {
            addCriterion("PK_GLORGBOOK not in", values, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookBetween(String value1, String value2) {
            addCriterion("PK_GLORGBOOK between", value1, value2, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotBetween(String value1, String value2) {
            addCriterion("PK_GLORGBOOK not between", value1, value2, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andFqmjbhIsNull() {
            addCriterion("FQMJBH is null");
            return (Criteria) this;
        }

        public Criteria andFqmjbhIsNotNull() {
            addCriterion("FQMJBH is not null");
            return (Criteria) this;
        }

        public Criteria andFqmjbhEqualTo(String value) {
            addCriterion("FQMJBH =", value, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhNotEqualTo(String value) {
            addCriterion("FQMJBH <>", value, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhGreaterThan(String value) {
            addCriterion("FQMJBH >", value, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhGreaterThanOrEqualTo(String value) {
            addCriterion("FQMJBH >=", value, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhLessThan(String value) {
            addCriterion("FQMJBH <", value, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhLessThanOrEqualTo(String value) {
            addCriterion("FQMJBH <=", value, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhLike(String value) {
            addCriterion("FQMJBH like", value, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhNotLike(String value) {
            addCriterion("FQMJBH not like", value, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhIn(List<String> values) {
            addCriterion("FQMJBH in", values, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhNotIn(List<String> values) {
            addCriterion("FQMJBH not in", values, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhBetween(String value1, String value2) {
            addCriterion("FQMJBH between", value1, value2, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andFqmjbhNotBetween(String value1, String value2) {
            addCriterion("FQMJBH not between", value1, value2, "fqmjbh");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyIsNull() {
            addCriterion("PK_VOUCHERTY is null");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyIsNotNull() {
            addCriterion("PK_VOUCHERTY is not null");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyEqualTo(String value) {
            addCriterion("PK_VOUCHERTY =", value, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyNotEqualTo(String value) {
            addCriterion("PK_VOUCHERTY <>", value, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyGreaterThan(String value) {
            addCriterion("PK_VOUCHERTY >", value, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHERTY >=", value, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyLessThan(String value) {
            addCriterion("PK_VOUCHERTY <", value, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHERTY <=", value, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyLike(String value) {
            addCriterion("PK_VOUCHERTY like", value, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyNotLike(String value) {
            addCriterion("PK_VOUCHERTY not like", value, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyIn(List<String> values) {
            addCriterion("PK_VOUCHERTY in", values, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyNotIn(List<String> values) {
            addCriterion("PK_VOUCHERTY not in", values, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyBetween(String value1, String value2) {
            addCriterion("PK_VOUCHERTY between", value1, value2, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkVouchertyNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHERTY not between", value1, value2, "pkVoucherty");
            return (Criteria) this;
        }

        public Criteria andPkSystemIsNull() {
            addCriterion("PK_SYSTEM is null");
            return (Criteria) this;
        }

        public Criteria andPkSystemIsNotNull() {
            addCriterion("PK_SYSTEM is not null");
            return (Criteria) this;
        }

        public Criteria andPkSystemEqualTo(String value) {
            addCriterion("PK_SYSTEM =", value, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemNotEqualTo(String value) {
            addCriterion("PK_SYSTEM <>", value, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemGreaterThan(String value) {
            addCriterion("PK_SYSTEM >", value, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemGreaterThanOrEqualTo(String value) {
            addCriterion("PK_SYSTEM >=", value, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemLessThan(String value) {
            addCriterion("PK_SYSTEM <", value, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemLessThanOrEqualTo(String value) {
            addCriterion("PK_SYSTEM <=", value, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemLike(String value) {
            addCriterion("PK_SYSTEM like", value, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemNotLike(String value) {
            addCriterion("PK_SYSTEM not like", value, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemIn(List<String> values) {
            addCriterion("PK_SYSTEM in", values, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemNotIn(List<String> values) {
            addCriterion("PK_SYSTEM not in", values, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemBetween(String value1, String value2) {
            addCriterion("PK_SYSTEM between", value1, value2, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andPkSystemNotBetween(String value1, String value2) {
            addCriterion("PK_SYSTEM not between", value1, value2, "pkSystem");
            return (Criteria) this;
        }

        public Criteria andTradecodeIsNull() {
            addCriterion("TRADECODE is null");
            return (Criteria) this;
        }

        public Criteria andTradecodeIsNotNull() {
            addCriterion("TRADECODE is not null");
            return (Criteria) this;
        }

        public Criteria andTradecodeEqualTo(String value) {
            addCriterion("TRADECODE =", value, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeNotEqualTo(String value) {
            addCriterion("TRADECODE <>", value, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeGreaterThan(String value) {
            addCriterion("TRADECODE >", value, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeGreaterThanOrEqualTo(String value) {
            addCriterion("TRADECODE >=", value, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeLessThan(String value) {
            addCriterion("TRADECODE <", value, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeLessThanOrEqualTo(String value) {
            addCriterion("TRADECODE <=", value, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeLike(String value) {
            addCriterion("TRADECODE like", value, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeNotLike(String value) {
            addCriterion("TRADECODE not like", value, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeIn(List<String> values) {
            addCriterion("TRADECODE in", values, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeNotIn(List<String> values) {
            addCriterion("TRADECODE not in", values, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeBetween(String value1, String value2) {
            addCriterion("TRADECODE between", value1, value2, "tradecode");
            return (Criteria) this;
        }

        public Criteria andTradecodeNotBetween(String value1, String value2) {
            addCriterion("TRADECODE not between", value1, value2, "tradecode");
            return (Criteria) this;
        }

        public Criteria andVouchertypeIsNull() {
            addCriterion("VOUCHERTYPE is null");
            return (Criteria) this;
        }

        public Criteria andVouchertypeIsNotNull() {
            addCriterion("VOUCHERTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andVouchertypeEqualTo(String value) {
            addCriterion("VOUCHERTYPE =", value, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeNotEqualTo(String value) {
            addCriterion("VOUCHERTYPE <>", value, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeGreaterThan(String value) {
            addCriterion("VOUCHERTYPE >", value, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeGreaterThanOrEqualTo(String value) {
            addCriterion("VOUCHERTYPE >=", value, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeLessThan(String value) {
            addCriterion("VOUCHERTYPE <", value, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeLessThanOrEqualTo(String value) {
            addCriterion("VOUCHERTYPE <=", value, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeLike(String value) {
            addCriterion("VOUCHERTYPE like", value, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeNotLike(String value) {
            addCriterion("VOUCHERTYPE not like", value, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeIn(List<String> values) {
            addCriterion("VOUCHERTYPE in", values, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeNotIn(List<String> values) {
            addCriterion("VOUCHERTYPE not in", values, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeBetween(String value1, String value2) {
            addCriterion("VOUCHERTYPE between", value1, value2, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andVouchertypeNotBetween(String value1, String value2) {
            addCriterion("VOUCHERTYPE not between", value1, value2, "vouchertype");
            return (Criteria) this;
        }

        public Criteria andAbstractsIsNull() {
            addCriterion("ABSTRACTS is null");
            return (Criteria) this;
        }

        public Criteria andAbstractsIsNotNull() {
            addCriterion("ABSTRACTS is not null");
            return (Criteria) this;
        }

        public Criteria andAbstractsEqualTo(String value) {
            addCriterion("ABSTRACTS =", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotEqualTo(String value) {
            addCriterion("ABSTRACTS <>", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsGreaterThan(String value) {
            addCriterion("ABSTRACTS >", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsGreaterThanOrEqualTo(String value) {
            addCriterion("ABSTRACTS >=", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLessThan(String value) {
            addCriterion("ABSTRACTS <", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLessThanOrEqualTo(String value) {
            addCriterion("ABSTRACTS <=", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLike(String value) {
            addCriterion("ABSTRACTS like", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotLike(String value) {
            addCriterion("ABSTRACTS not like", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsIn(List<String> values) {
            addCriterion("ABSTRACTS in", values, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotIn(List<String> values) {
            addCriterion("ABSTRACTS not in", values, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsBetween(String value1, String value2) {
            addCriterion("ABSTRACTS between", value1, value2, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotBetween(String value1, String value2) {
            addCriterion("ABSTRACTS not between", value1, value2, "abstracts");
            return (Criteria) this;
        }

        public Criteria andPkPreparedIsNull() {
            addCriterion("PK_PREPARED is null");
            return (Criteria) this;
        }

        public Criteria andPkPreparedIsNotNull() {
            addCriterion("PK_PREPARED is not null");
            return (Criteria) this;
        }

        public Criteria andPkPreparedEqualTo(String value) {
            addCriterion("PK_PREPARED =", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotEqualTo(String value) {
            addCriterion("PK_PREPARED <>", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedGreaterThan(String value) {
            addCriterion("PK_PREPARED >", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedGreaterThanOrEqualTo(String value) {
            addCriterion("PK_PREPARED >=", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedLessThan(String value) {
            addCriterion("PK_PREPARED <", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedLessThanOrEqualTo(String value) {
            addCriterion("PK_PREPARED <=", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedLike(String value) {
            addCriterion("PK_PREPARED like", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotLike(String value) {
            addCriterion("PK_PREPARED not like", value, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedIn(List<String> values) {
            addCriterion("PK_PREPARED in", values, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotIn(List<String> values) {
            addCriterion("PK_PREPARED not in", values, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedBetween(String value1, String value2) {
            addCriterion("PK_PREPARED between", value1, value2, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPkPreparedNotBetween(String value1, String value2) {
            addCriterion("PK_PREPARED not between", value1, value2, "pkPrepared");
            return (Criteria) this;
        }

        public Criteria andPreparedateIsNull() {
            addCriterion("PREPAREDATE is null");
            return (Criteria) this;
        }

        public Criteria andPreparedateIsNotNull() {
            addCriterion("PREPAREDATE is not null");
            return (Criteria) this;
        }

        public Criteria andPreparedateEqualTo(Date value) {
            addCriterionForJDBCDate("PREPAREDATE =", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotEqualTo(Date value) {
            addCriterionForJDBCDate("PREPAREDATE <>", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateGreaterThan(Date value) {
            addCriterionForJDBCDate("PREPAREDATE >", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("PREPAREDATE >=", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateLessThan(Date value) {
            addCriterionForJDBCDate("PREPAREDATE <", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("PREPAREDATE <=", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateIn(List<Date> values) {
            addCriterionForJDBCDate("PREPAREDATE in", values, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotIn(List<Date> values) {
            addCriterionForJDBCDate("PREPAREDATE not in", values, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("PREPAREDATE between", value1, value2, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("PREPAREDATE not between", value1, value2, "preparedate");
            return (Criteria) this;
        }

        public Criteria andIsauditIsNull() {
            addCriterion("ISAUDIT is null");
            return (Criteria) this;
        }

        public Criteria andIsauditIsNotNull() {
            addCriterion("ISAUDIT is not null");
            return (Criteria) this;
        }

        public Criteria andIsauditEqualTo(String value) {
            addCriterion("ISAUDIT =", value, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditNotEqualTo(String value) {
            addCriterion("ISAUDIT <>", value, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditGreaterThan(String value) {
            addCriterion("ISAUDIT >", value, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditGreaterThanOrEqualTo(String value) {
            addCriterion("ISAUDIT >=", value, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditLessThan(String value) {
            addCriterion("ISAUDIT <", value, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditLessThanOrEqualTo(String value) {
            addCriterion("ISAUDIT <=", value, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditLike(String value) {
            addCriterion("ISAUDIT like", value, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditNotLike(String value) {
            addCriterion("ISAUDIT not like", value, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditIn(List<String> values) {
            addCriterion("ISAUDIT in", values, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditNotIn(List<String> values) {
            addCriterion("ISAUDIT not in", values, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditBetween(String value1, String value2) {
            addCriterion("ISAUDIT between", value1, value2, "isaudit");
            return (Criteria) this;
        }

        public Criteria andIsauditNotBetween(String value1, String value2) {
            addCriterion("ISAUDIT not between", value1, value2, "isaudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditIsNull() {
            addCriterion("PK_AUDIT is null");
            return (Criteria) this;
        }

        public Criteria andPkAuditIsNotNull() {
            addCriterion("PK_AUDIT is not null");
            return (Criteria) this;
        }

        public Criteria andPkAuditEqualTo(String value) {
            addCriterion("PK_AUDIT =", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditNotEqualTo(String value) {
            addCriterion("PK_AUDIT <>", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditGreaterThan(String value) {
            addCriterion("PK_AUDIT >", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditGreaterThanOrEqualTo(String value) {
            addCriterion("PK_AUDIT >=", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditLessThan(String value) {
            addCriterion("PK_AUDIT <", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditLessThanOrEqualTo(String value) {
            addCriterion("PK_AUDIT <=", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditLike(String value) {
            addCriterion("PK_AUDIT like", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditNotLike(String value) {
            addCriterion("PK_AUDIT not like", value, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditIn(List<String> values) {
            addCriterion("PK_AUDIT in", values, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditNotIn(List<String> values) {
            addCriterion("PK_AUDIT not in", values, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditBetween(String value1, String value2) {
            addCriterion("PK_AUDIT between", value1, value2, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andPkAuditNotBetween(String value1, String value2) {
            addCriterion("PK_AUDIT not between", value1, value2, "pkAudit");
            return (Criteria) this;
        }

        public Criteria andAuditdateIsNull() {
            addCriterion("AUDITDATE is null");
            return (Criteria) this;
        }

        public Criteria andAuditdateIsNotNull() {
            addCriterion("AUDITDATE is not null");
            return (Criteria) this;
        }

        public Criteria andAuditdateEqualTo(Date value) {
            addCriterionForJDBCDate("AUDITDATE =", value, "auditdate");
            return (Criteria) this;
        }

        public Criteria andAuditdateNotEqualTo(Date value) {
            addCriterionForJDBCDate("AUDITDATE <>", value, "auditdate");
            return (Criteria) this;
        }

        public Criteria andAuditdateGreaterThan(Date value) {
            addCriterionForJDBCDate("AUDITDATE >", value, "auditdate");
            return (Criteria) this;
        }

        public Criteria andAuditdateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("AUDITDATE >=", value, "auditdate");
            return (Criteria) this;
        }

        public Criteria andAuditdateLessThan(Date value) {
            addCriterionForJDBCDate("AUDITDATE <", value, "auditdate");
            return (Criteria) this;
        }

        public Criteria andAuditdateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("AUDITDATE <=", value, "auditdate");
            return (Criteria) this;
        }

        public Criteria andAuditdateIn(List<Date> values) {
            addCriterionForJDBCDate("AUDITDATE in", values, "auditdate");
            return (Criteria) this;
        }

        public Criteria andAuditdateNotIn(List<Date> values) {
            addCriterionForJDBCDate("AUDITDATE not in", values, "auditdate");
            return (Criteria) this;
        }

        public Criteria andAuditdateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("AUDITDATE between", value1, value2, "auditdate");
            return (Criteria) this;
        }

        public Criteria andAuditdateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("AUDITDATE not between", value1, value2, "auditdate");
            return (Criteria) this;
        }

        public Criteria andIssignIsNull() {
            addCriterion("ISSIGN is null");
            return (Criteria) this;
        }

        public Criteria andIssignIsNotNull() {
            addCriterion("ISSIGN is not null");
            return (Criteria) this;
        }

        public Criteria andIssignEqualTo(String value) {
            addCriterion("ISSIGN =", value, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignNotEqualTo(String value) {
            addCriterion("ISSIGN <>", value, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignGreaterThan(String value) {
            addCriterion("ISSIGN >", value, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignGreaterThanOrEqualTo(String value) {
            addCriterion("ISSIGN >=", value, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignLessThan(String value) {
            addCriterion("ISSIGN <", value, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignLessThanOrEqualTo(String value) {
            addCriterion("ISSIGN <=", value, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignLike(String value) {
            addCriterion("ISSIGN like", value, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignNotLike(String value) {
            addCriterion("ISSIGN not like", value, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignIn(List<String> values) {
            addCriterion("ISSIGN in", values, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignNotIn(List<String> values) {
            addCriterion("ISSIGN not in", values, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignBetween(String value1, String value2) {
            addCriterion("ISSIGN between", value1, value2, "issign");
            return (Criteria) this;
        }

        public Criteria andIssignNotBetween(String value1, String value2) {
            addCriterion("ISSIGN not between", value1, value2, "issign");
            return (Criteria) this;
        }

        public Criteria andPkSignIsNull() {
            addCriterion("PK_SIGN is null");
            return (Criteria) this;
        }

        public Criteria andPkSignIsNotNull() {
            addCriterion("PK_SIGN is not null");
            return (Criteria) this;
        }

        public Criteria andPkSignEqualTo(String value) {
            addCriterion("PK_SIGN =", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignNotEqualTo(String value) {
            addCriterion("PK_SIGN <>", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignGreaterThan(String value) {
            addCriterion("PK_SIGN >", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignGreaterThanOrEqualTo(String value) {
            addCriterion("PK_SIGN >=", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignLessThan(String value) {
            addCriterion("PK_SIGN <", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignLessThanOrEqualTo(String value) {
            addCriterion("PK_SIGN <=", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignLike(String value) {
            addCriterion("PK_SIGN like", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignNotLike(String value) {
            addCriterion("PK_SIGN not like", value, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignIn(List<String> values) {
            addCriterion("PK_SIGN in", values, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignNotIn(List<String> values) {
            addCriterion("PK_SIGN not in", values, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignBetween(String value1, String value2) {
            addCriterion("PK_SIGN between", value1, value2, "pkSign");
            return (Criteria) this;
        }

        public Criteria andPkSignNotBetween(String value1, String value2) {
            addCriterion("PK_SIGN not between", value1, value2, "pkSign");
            return (Criteria) this;
        }

        public Criteria andSigndateIsNull() {
            addCriterion("SIGNDATE is null");
            return (Criteria) this;
        }

        public Criteria andSigndateIsNotNull() {
            addCriterion("SIGNDATE is not null");
            return (Criteria) this;
        }

        public Criteria andSigndateEqualTo(Date value) {
            addCriterionForJDBCDate("SIGNDATE =", value, "signdate");
            return (Criteria) this;
        }

        public Criteria andSigndateNotEqualTo(Date value) {
            addCriterionForJDBCDate("SIGNDATE <>", value, "signdate");
            return (Criteria) this;
        }

        public Criteria andSigndateGreaterThan(Date value) {
            addCriterionForJDBCDate("SIGNDATE >", value, "signdate");
            return (Criteria) this;
        }

        public Criteria andSigndateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("SIGNDATE >=", value, "signdate");
            return (Criteria) this;
        }

        public Criteria andSigndateLessThan(Date value) {
            addCriterionForJDBCDate("SIGNDATE <", value, "signdate");
            return (Criteria) this;
        }

        public Criteria andSigndateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("SIGNDATE <=", value, "signdate");
            return (Criteria) this;
        }

        public Criteria andSigndateIn(List<Date> values) {
            addCriterionForJDBCDate("SIGNDATE in", values, "signdate");
            return (Criteria) this;
        }

        public Criteria andSigndateNotIn(List<Date> values) {
            addCriterionForJDBCDate("SIGNDATE not in", values, "signdate");
            return (Criteria) this;
        }

        public Criteria andSigndateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("SIGNDATE between", value1, value2, "signdate");
            return (Criteria) this;
        }

        public Criteria andSigndateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("SIGNDATE not between", value1, value2, "signdate");
            return (Criteria) this;
        }

        public Criteria andVouchernoIsNull() {
            addCriterion("VOUCHERNO is null");
            return (Criteria) this;
        }

        public Criteria andVouchernoIsNotNull() {
            addCriterion("VOUCHERNO is not null");
            return (Criteria) this;
        }

        public Criteria andVouchernoEqualTo(String value) {
            addCriterion("VOUCHERNO =", value, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoNotEqualTo(String value) {
            addCriterion("VOUCHERNO <>", value, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoGreaterThan(String value) {
            addCriterion("VOUCHERNO >", value, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoGreaterThanOrEqualTo(String value) {
            addCriterion("VOUCHERNO >=", value, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoLessThan(String value) {
            addCriterion("VOUCHERNO <", value, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoLessThanOrEqualTo(String value) {
            addCriterion("VOUCHERNO <=", value, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoLike(String value) {
            addCriterion("VOUCHERNO like", value, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoNotLike(String value) {
            addCriterion("VOUCHERNO not like", value, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoIn(List<String> values) {
            addCriterion("VOUCHERNO in", values, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoNotIn(List<String> values) {
            addCriterion("VOUCHERNO not in", values, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoBetween(String value1, String value2) {
            addCriterion("VOUCHERNO between", value1, value2, "voucherno");
            return (Criteria) this;
        }

        public Criteria andVouchernoNotBetween(String value1, String value2) {
            addCriterion("VOUCHERNO not between", value1, value2, "voucherno");
            return (Criteria) this;
        }

        public Criteria andIsmodifyIsNull() {
            addCriterion("ISMODIFY is null");
            return (Criteria) this;
        }

        public Criteria andIsmodifyIsNotNull() {
            addCriterion("ISMODIFY is not null");
            return (Criteria) this;
        }

        public Criteria andIsmodifyEqualTo(String value) {
            addCriterion("ISMODIFY =", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyNotEqualTo(String value) {
            addCriterion("ISMODIFY <>", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyGreaterThan(String value) {
            addCriterion("ISMODIFY >", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyGreaterThanOrEqualTo(String value) {
            addCriterion("ISMODIFY >=", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyLessThan(String value) {
            addCriterion("ISMODIFY <", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyLessThanOrEqualTo(String value) {
            addCriterion("ISMODIFY <=", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyLike(String value) {
            addCriterion("ISMODIFY like", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyNotLike(String value) {
            addCriterion("ISMODIFY not like", value, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyIn(List<String> values) {
            addCriterion("ISMODIFY in", values, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyNotIn(List<String> values) {
            addCriterion("ISMODIFY not in", values, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyBetween(String value1, String value2) {
            addCriterion("ISMODIFY between", value1, value2, "ismodify");
            return (Criteria) this;
        }

        public Criteria andIsmodifyNotBetween(String value1, String value2) {
            addCriterion("ISMODIFY not between", value1, value2, "ismodify");
            return (Criteria) this;
        }

        public Criteria andYearIsNull() {
            addCriterion("YEAR is null");
            return (Criteria) this;
        }

        public Criteria andYearIsNotNull() {
            addCriterion("YEAR is not null");
            return (Criteria) this;
        }

        public Criteria andYearEqualTo(String value) {
            addCriterion("YEAR =", value, "year");
            return (Criteria) this;
        }

        public Criteria andYearNotEqualTo(String value) {
            addCriterion("YEAR <>", value, "year");
            return (Criteria) this;
        }

        public Criteria andYearGreaterThan(String value) {
            addCriterion("YEAR >", value, "year");
            return (Criteria) this;
        }

        public Criteria andYearGreaterThanOrEqualTo(String value) {
            addCriterion("YEAR >=", value, "year");
            return (Criteria) this;
        }

        public Criteria andYearLessThan(String value) {
            addCriterion("YEAR <", value, "year");
            return (Criteria) this;
        }

        public Criteria andYearLessThanOrEqualTo(String value) {
            addCriterion("YEAR <=", value, "year");
            return (Criteria) this;
        }

        public Criteria andYearLike(String value) {
            addCriterion("YEAR like", value, "year");
            return (Criteria) this;
        }

        public Criteria andYearNotLike(String value) {
            addCriterion("YEAR not like", value, "year");
            return (Criteria) this;
        }

        public Criteria andYearIn(List<String> values) {
            addCriterion("YEAR in", values, "year");
            return (Criteria) this;
        }

        public Criteria andYearNotIn(List<String> values) {
            addCriterion("YEAR not in", values, "year");
            return (Criteria) this;
        }

        public Criteria andYearBetween(String value1, String value2) {
            addCriterion("YEAR between", value1, value2, "year");
            return (Criteria) this;
        }

        public Criteria andYearNotBetween(String value1, String value2) {
            addCriterion("YEAR not between", value1, value2, "year");
            return (Criteria) this;
        }

        public Criteria andPeriodIsNull() {
            addCriterion("PERIOD is null");
            return (Criteria) this;
        }

        public Criteria andPeriodIsNotNull() {
            addCriterion("PERIOD is not null");
            return (Criteria) this;
        }

        public Criteria andPeriodEqualTo(String value) {
            addCriterion("PERIOD =", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodNotEqualTo(String value) {
            addCriterion("PERIOD <>", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodGreaterThan(String value) {
            addCriterion("PERIOD >", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodGreaterThanOrEqualTo(String value) {
            addCriterion("PERIOD >=", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodLessThan(String value) {
            addCriterion("PERIOD <", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodLessThanOrEqualTo(String value) {
            addCriterion("PERIOD <=", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodLike(String value) {
            addCriterion("PERIOD like", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodNotLike(String value) {
            addCriterion("PERIOD not like", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodIn(List<String> values) {
            addCriterion("PERIOD in", values, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodNotIn(List<String> values) {
            addCriterion("PERIOD not in", values, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodBetween(String value1, String value2) {
            addCriterion("PERIOD between", value1, value2, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodNotBetween(String value1, String value2) {
            addCriterion("PERIOD not between", value1, value2, "period");
            return (Criteria) this;
        }

        public Criteria andTempsaveIsNull() {
            addCriterion("TEMPSAVE is null");
            return (Criteria) this;
        }

        public Criteria andTempsaveIsNotNull() {
            addCriterion("TEMPSAVE is not null");
            return (Criteria) this;
        }

        public Criteria andTempsaveEqualTo(String value) {
            addCriterion("TEMPSAVE =", value, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveNotEqualTo(String value) {
            addCriterion("TEMPSAVE <>", value, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveGreaterThan(String value) {
            addCriterion("TEMPSAVE >", value, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveGreaterThanOrEqualTo(String value) {
            addCriterion("TEMPSAVE >=", value, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveLessThan(String value) {
            addCriterion("TEMPSAVE <", value, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveLessThanOrEqualTo(String value) {
            addCriterion("TEMPSAVE <=", value, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveLike(String value) {
            addCriterion("TEMPSAVE like", value, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveNotLike(String value) {
            addCriterion("TEMPSAVE not like", value, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveIn(List<String> values) {
            addCriterion("TEMPSAVE in", values, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveNotIn(List<String> values) {
            addCriterion("TEMPSAVE not in", values, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveBetween(String value1, String value2) {
            addCriterion("TEMPSAVE between", value1, value2, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTempsaveNotBetween(String value1, String value2) {
            addCriterion("TEMPSAVE not between", value1, value2, "tempsave");
            return (Criteria) this;
        }

        public Criteria andTotaldebitIsNull() {
            addCriterion("TOTALDEBIT is null");
            return (Criteria) this;
        }

        public Criteria andTotaldebitIsNotNull() {
            addCriterion("TOTALDEBIT is not null");
            return (Criteria) this;
        }

        public Criteria andTotaldebitEqualTo(BigDecimal value) {
            addCriterion("TOTALDEBIT =", value, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotaldebitNotEqualTo(BigDecimal value) {
            addCriterion("TOTALDEBIT <>", value, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotaldebitGreaterThan(BigDecimal value) {
            addCriterion("TOTALDEBIT >", value, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotaldebitGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("TOTALDEBIT >=", value, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotaldebitLessThan(BigDecimal value) {
            addCriterion("TOTALDEBIT <", value, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotaldebitLessThanOrEqualTo(BigDecimal value) {
            addCriterion("TOTALDEBIT <=", value, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotaldebitIn(List<BigDecimal> values) {
            addCriterion("TOTALDEBIT in", values, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotaldebitNotIn(List<BigDecimal> values) {
            addCriterion("TOTALDEBIT not in", values, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotaldebitBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("TOTALDEBIT between", value1, value2, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotaldebitNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("TOTALDEBIT not between", value1, value2, "totaldebit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditIsNull() {
            addCriterion("TOTALCREDIT is null");
            return (Criteria) this;
        }

        public Criteria andTotalcreditIsNotNull() {
            addCriterion("TOTALCREDIT is not null");
            return (Criteria) this;
        }

        public Criteria andTotalcreditEqualTo(BigDecimal value) {
            addCriterion("TOTALCREDIT =", value, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditNotEqualTo(BigDecimal value) {
            addCriterion("TOTALCREDIT <>", value, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditGreaterThan(BigDecimal value) {
            addCriterion("TOTALCREDIT >", value, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("TOTALCREDIT >=", value, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditLessThan(BigDecimal value) {
            addCriterion("TOTALCREDIT <", value, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditLessThanOrEqualTo(BigDecimal value) {
            addCriterion("TOTALCREDIT <=", value, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditIn(List<BigDecimal> values) {
            addCriterion("TOTALCREDIT in", values, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditNotIn(List<BigDecimal> values) {
            addCriterion("TOTALCREDIT not in", values, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("TOTALCREDIT between", value1, value2, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andTotalcreditNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("TOTALCREDIT not between", value1, value2, "totalcredit");
            return (Criteria) this;
        }

        public Criteria andOccDateIsNull() {
            addCriterion("OCC_DATE is null");
            return (Criteria) this;
        }

        public Criteria andOccDateIsNotNull() {
            addCriterion("OCC_DATE is not null");
            return (Criteria) this;
        }

        public Criteria andOccDateEqualTo(Date value) {
            addCriterion("OCC_DATE =", value, "occDate");
            return (Criteria) this;
        }

        public Criteria andOccDateNotEqualTo(Date value) {
            addCriterion("OCC_DATE <>", value, "occDate");
            return (Criteria) this;
        }

        public Criteria andOccDateGreaterThan(Date value) {
            addCriterion("OCC_DATE >", value, "occDate");
            return (Criteria) this;
        }

        public Criteria andOccDateGreaterThanOrEqualTo(Date value) {
            addCriterion("OCC_DATE >=", value, "occDate");
            return (Criteria) this;
        }

        public Criteria andOccDateLessThan(Date value) {
            addCriterion("OCC_DATE <", value, "occDate");
            return (Criteria) this;
        }

        public Criteria andOccDateLessThanOrEqualTo(Date value) {
            addCriterion("OCC_DATE <=", value, "occDate");
            return (Criteria) this;
        }

        public Criteria andOccDateIn(List<Date> values) {
            addCriterion("OCC_DATE in", values, "occDate");
            return (Criteria) this;
        }

        public Criteria andOccDateNotIn(List<Date> values) {
            addCriterion("OCC_DATE not in", values, "occDate");
            return (Criteria) this;
        }

        public Criteria andOccDateBetween(Date value1, Date value2) {
            addCriterion("OCC_DATE between", value1, value2, "occDate");
            return (Criteria) this;
        }

        public Criteria andOccDateNotBetween(Date value1, Date value2) {
            addCriterion("OCC_DATE not between", value1, value2, "occDate");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    /**
     *  * cw_gl_voucher
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * cw_gl_voucher 2019-10-14
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}